<?
/*
┌┬─┬────────────────────────────────────────────────────────────────────────────────────┬─┬┐
│└─┘                             created by: DarMar (2015)                              └─┘│
└──────────────────────────────────────────────────────────────────────────────────────────┘
┌────────────────────────────────────────────┐ ┌────────────────────────────────────────────┐
│                (functions)                 │ │                (functions)                 │
│ GETS MONTHLY OR SPECIAL TOURNAMENT SCORES  │ │    CHECK IF USER PASSED QUALIFICATIONS     │
╠════════════════════════════════════════════╣ ╠════════════════════════════════════════════╣
║EXAMPLE JSON command:                       ║ ║EXAMPLE JSON command:                       ║
║                                            ║ ║                                            ║
║{                                           ║ ║{                                           ║
║    "SERVER":{                              ║ ║    "SERVER":{                              ║
║        "hash":"some hash here",            ║ ║        "hash":"some hash here",            ║
║        "game_name":"SWC",                  ║ ║        "game_name":"SWC",                  ║
║        "game_version":"1.0.0",             ║ ║        "game_version":"1.4.7",             ║
║        "command":"get_scores",             ║ ║        "command":"check_pass",             ║
║        "options":{                         ║ ║        "options":{                         ║
║            "type":"global",                ║ ║            "type":"special", or (monthly)  ║
║            "list_limit":"4",               ║ ║            "user_id":"2",                  ║
║            "with_id":"true",  or(false)    ║ ║            "with_limit":"3"                ║
║            "with_date":"true" or(false)    ║ ║        }                                   ║
║        }                                   ║ ║    }                                       ║
║    }                                       ║ ║}                                           ║
║}                                           ║ ║                                            ║
║                                            ║ ║                                            ║
╠────────────────────────────────────────────╣ ╚════════════════════════════════════════════╝
│               TYPE OPTIONS:                │
│    monthly_qualify (or) monthly_finale     │
│    special_qualify (or) special_finale     │
└────────────────────────────────────────────┘
*/


// ukloni warning errore, tako da dobijemo cisti hardkodani error report
ini_set('display_errors', '0');
// set header for JSON type
header('Content-Type: application/json');

//MYSQL DATABSE PASSWORD IN THIS FILE
include 'server_data.php';   // <-------  PASSWORD / HOST NAME / USER / DATABASE NAME / UNITY HASH CODE / GAME BUILD VERSION  <--------- IN THIS FILE

// ANTI INJECTIONS IN THIS FILE
include 'anti_injection.php';
// server messages which we return
include 'server_messages.php';

$jsondata = $_POST["UNITY_json"];
// $jsondata = file_get_contents("test_scores_get.json");
// $jsondata = file_get_contents("test_scores_check.json");
$json = json_decode($jsondata, true);






// CONNECTIONS =================================================================
//*** note: These variables are declared in the 'server_data.php' file
mysql_connect($host, $user, $password) or die( FailConnectMessage ()  );
mysql_select_db($dbname)or die( FailSelectMessage () );
// =============================================================================




//ALL THE STUFF FROM THE GAME ==============================================
//HASHCODE RECEIVED FROM THE GAME
$unityHash = $json['SERVER']['hash'];
//GAME VERSION
$ReceiveGameVersion = $json['SERVER']['game_version'];


// command action we want to execute
$formAction = $json['SERVER']['command'];





    //VERIFY THE HASHCODE FROM THE GAME AND THE WEB HASHCODE
    if ($unityHash != $phpHash){

		    //TELL THAT THE HASHCODE FROM UNITY IS NOT AS THIS PAGE
        BadHashCode ();
        

    } else {

        //VERIFY THE GAME VERSION
		    if($UnityBuildVersion != $ReceiveGameVersion) {

      			//TELL TO THE GAME THAT WE USE A OLD VERSION
            BadGameVersion ($UnityBuildVersion, $ReceiveGameVersion);

      			//STOP THE PHP SCRIPT
      			return;
		    }

            // ========================================================================================================== GET SCORES BEGIN
            // LOADS only first three (if not more given) scores from table we need for LED display in player room
            if($formAction == "get_scores") {

              // GET SCORES variables we encrypt from JSON
              $type       = $json['SERVER']['options']['type'];
              $list_limit = $json['SERVER']['options']['list_limit'];
              $with_id    = $json['SERVER']['options']['with_id'];
              $with_date  = $json['SERVER']['options']['with_date'];

              // HERE we begin to get scores needed from tables

                if ($type=="monthly_qualify") { // ============================ MONTHLY QUALIFY BEGIN
                      // Try EXECUTE QUERRY
          			      $SQL = "SELECT month_qualify.u_id, month_qualify.score, month_qualify.scored, u_profile.nickname, u_profile.country FROM month_qualify, u_profile WHERE month_qualify.u_id = u_profile.id ORDER BY month_qualify.score DESC LIMIT $list_limit ";
          			      //GIVE THE RESULT
          			      $result_id = @mysql_query($SQL) or die( FailQuerryMessage () );
          			      $total = mysql_num_rows($result_id);

              			      if($total) {
                              // predefiniraj arraj za povratak JSON bodova
                              $za_json= array();
                              // loop gdje fetcha bodove
                              while ($data = @mysql_fetch_array($result_id) ) {

                                  // vraca skor listu sa ID i DATE
                                  if ($with_id=='true' && $with_date=='true' ){
                                    $za_json[] = array ( 'id' => $data['u_id'], 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'], 'date' => $data['scored'] );
                                  }else{

                                    // vraca skor listu bez ID i DATE
                                    if ($with_id=='false' && $with_date=='false' ){
                                        $za_json[] = array ( 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'] );
                                    }else{
                                        // vraca skor samo sa ID
                                        if ($with_id=='true' ){
                                            $za_json[] = array ( 'id' => $data['u_id'], 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'] );
                                        }
                                        // vraca skor samo sa DATE
                                        if ($with_date=='true' ){
                                            $za_json[] = array ( 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'], 'date' => $data['scored'] );
                                        }
                                    }

                                  }

                              }

                              echo json_encode ($za_json);

                          }
                } // ========================================================== MONTHLY QUALIFY END


                if ($type=="monthly_finale") { // ============================= MONTHLY FINALE BEGIN
                      // Try EXECUTE QUERRY
          			      $SQL = "SELECT month_finale.u_id, month_finale.score, month_finale.scored, u_profile.nickname, u_profile.country FROM month_finale, u_profile WHERE month_finale.u_id = u_profile.id ORDER BY month_finale.score DESC LIMIT $list_limit ";
          			      //GIVE THE RESULT
          			      $result_id = @mysql_query($SQL) or die( FailQuerryMessage () );
          			      $total = mysql_num_rows($result_id);

              			      if($total) {
                              // predefiniraj arraj za povratak JSON bodova
                              $za_json= array();
                              // loop gdje fetcha bodove
                              while ($data = @mysql_fetch_array($result_id) ) {

                                  // vraca skor listu sa ID i DATE
                                  if ($with_id=='true' && $with_date=='true' ){
                                    $za_json[] = array ( 'id' => $data['u_id'], 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'], 'date' => $data['scored'] );
                                  }else{

                                    // vraca skor listu bez ID i DATE
                                    if ($with_id=='false' && $with_date=='false' ){
                                        $za_json[] = array ( 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'] );
                                    }else{
                                        // vraca skor samo sa ID
                                        if ($with_id=='true' ){
                                            $za_json[] = array ( 'id' => $data['u_id'], 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'] );
                                        }
                                        // vraca skor samo sa DATE
                                        if ($with_date=='true' ){
                                            $za_json[] = array ( 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'], 'date' => $data['scored'] );
                                        }
                                    }

                                  }

                              }

                              echo json_encode ($za_json);

                          }
                } // ========================================================== MONTHLY FINALE END



                if ($type=="special_qualify") { // ============================ SPECIAL QUALIFY BEGIN
                      // Try EXECUTE QUERRY
          			      $SQL = "SELECT special_qualify.u_id, special_qualify.score, special_qualify.scored, u_profile.nickname, u_profile.country FROM special_qualify, u_profile WHERE special_qualify.u_id = u_profile.id ORDER BY special_qualify.score DESC LIMIT $list_limit ";
          			      //GIVE THE RESULT
          			      $result_id = @mysql_query($SQL) or die( FailQuerryMessage () );
          			      $total = mysql_num_rows($result_id);

              			      if($total) {
                              // predefiniraj arraj za povratak JSON bodova
                              $za_json= array();
                              // loop gdje fetcha bodove
                              while ($data = @mysql_fetch_array($result_id) ) {

                                  // vraca skor listu sa ID i DATE
                                  if ($with_id=='true' && $with_date=='true' ){
                                    $za_json[] = array ( 'id' => $data['u_id'], 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'], 'date' => $data['scored'] );
                                  }else{

                                    // vraca skor listu bez ID i DATE
                                    if ($with_id=='false' && $with_date=='false' ){
                                        $za_json[] = array ( 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'] );
                                    }else{
                                        // vraca skor samo sa ID
                                        if ($with_id=='true' ){
                                            $za_json[] = array ( 'id' => $data['u_id'], 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'] );
                                        }
                                        // vraca skor samo sa DATE
                                        if ($with_date=='true' ){
                                            $za_json[] = array ( 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'], 'date' => $data['scored'] );
                                        }
                                    }

                                  }

                              }

                              echo json_encode ($za_json);

                          }
                } // ========================================================== SPECIAL QUALIFY END


                if ($type=="special_finale") { // ============================= SPECIAL FINALE BEGIN
                      // Try EXECUTE QUERRY
          			      $SQL = "SELECT special_finale.u_id, special_finale.score, special_finale.scored, u_profile.nickname, u_profile.country FROM special_finale, u_profile WHERE special_finale.u_id = u_profile.id ORDER BY special_finale.score DESC LIMIT $list_limit ";
          			      //GIVE THE RESULT
          			      $result_id = @mysql_query($SQL) or die( FailQuerryMessage () );
          			      $total = mysql_num_rows($result_id);

              			      if($total) {
                              // predefiniraj arraj za povratak JSON bodova
                              $za_json= array();
                              // loop gdje fetcha bodove
                              while ($data = @mysql_fetch_array($result_id) ) {

                                  // vraca skor listu sa ID i DATE
                                  if ($with_id=='true' && $with_date=='true' ){
                                    $za_json[] = array ( 'id' => $data['u_id'], 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'], 'date' => $data['scored'] );
                                  }else{

                                    // vraca skor listu bez ID i DATE
                                    if ($with_id=='false' && $with_date=='false' ){
                                        $za_json[] = array ( 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'] );
                                    }else{
                                        // vraca skor samo sa ID
                                        if ($with_id=='true' ){
                                            $za_json[] = array ( 'id' => $data['u_id'], 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'] );
                                        }
                                        // vraca skor samo sa DATE
                                        if ($with_date=='true' ){
                                            $za_json[] = array ( 'name' => $data['nickname'], 'country' => $data['country'], 'score' => $data['score'], 'date' => $data['scored'] );
                                        }
                                    }

                                  }

                              }

                              echo json_encode ($za_json);

                          }
                } // ========================================================== SPECIAL FINALE END




          }// ========================================================================================================== GET SCORES END


// ================================================================================================ //
//                                   S P A C E S                                                    //
// ================================================================================================ //


          if($formAction == "check_pass") { // ========================================================================= CHECK PASS BEGIN
            // GET and SET needed variables from JSON
            $with_id    = $json['SERVER']['options']['user_id'];
            $type       = $json['SERVER']['options']['type'];
            $with_limit = $json['SERVER']['options']['with_limit'];

              if ($type=='monthly') { // ====================================== MONTHLY BEGIN
                  //VERIFY IF THE USERNAME ALREADY EXIST
            			$SQL = "SELECT * FROM month_qualify WHERE u_id = '" .$with_id. "'";
                  //GIVE THE RESULT
            			$result_id = @mysql_query($SQL) or die( FailQuerryMessage () );
            			$total = mysql_num_rows($result_id);

                    if($total) {
                        // do ranking querry and fetch result
                        $result = "SELECT u_id, score, scored, FIND_IN_SET( score, ( SELECT GROUP_CONCAT( score ORDER BY score DESC ) FROM month_qualify ) ) AS rank FROM month_qualify WHERE u_id =  '" .$with_id. "'";
                        $result_id = @mysql_query($result) or die( FailQuerryMessage () );
                        $data = @mysql_fetch_assoc($result_id);

                        // convert ranks to float variables for best comparement
                        $needed_rank= floatval($with_limit);
                        $querid_rank= floatval($data['rank']);

                        if ($querid_rank <= $needed_rank) {
                            // we pass here
                            QualifyPass ($data['rank']);
                        }else{
                            // and here we fail to pass
                            QualifyNoPass ($data['rank']);
                        }
                    }else{
                      // no such user in table at all
                      QualifyFailListing ();

                    }
              } // ============================================================ MONTHLY END


// ================================================================================================ //
//                                   S P A C E S                                                    //
// ================================================================================================ //


              if ($type=='special') { // ====================================== SPECIAL BEGIN
                  //VERIFY IF THE USERNAME ALREADY EXIST
            			$SQL = "SELECT * FROM special_qualify WHERE u_id = '" .$with_id. "'";
                  //GIVE THE RESULT
            			$result_id = @mysql_query($SQL) or die( FailQuerryMessage () );
            			$total = mysql_num_rows($result_id);

                    if($total) {
                        // do ranking querry and fetch result
                        $result = "SELECT u_id, score, scored, FIND_IN_SET( score, ( SELECT GROUP_CONCAT( score ORDER BY score DESC ) FROM special_qualify ) ) AS rank FROM special_qualify WHERE u_id =  '" .$with_id. "'";
                        $result_id = @mysql_query($result) or die( FailQuerryMessage () );
                        $data = @mysql_fetch_assoc($result_id);

                        // convert ranks to float variables for best comparement
                        $needed_rank= floatval($with_limit);
                        $querid_rank= floatval($data['rank']);

                        if ($querid_rank <= $needed_rank) {
                            // we pass here
                            QualifyPass ($data['rank']);
                        }else{
                            // and here we fail to pass
                            QualifyNoPass ($data['rank']);
                        }
                    }else{
                      // no such user in table at all
                      QualifyFailListing ();

                    }
              } // ============================================================ SPECIAL END

          }   // ======================================================================================================= CHECK PASS END





    }// Hash check end


//CLOSE mySQL CONNECTION
mysql_close();

//END OF PAGE
?>
