<?php


// vraca informaciju da nemoze konektirat na databazu
function FailConnectMessage () {
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason'] = 'can not connect to database';

  echo json_encode($givebackdata);
}

// vraca info da nemoze selektirat nista u bazi
function FailSelectMessage () {
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason'] = 'can not select database';

  echo json_encode($givebackdata);

}

// if we fail to querry database
function FailQuerryMessage () {
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason'] = 'database querry error';

  echo json_encode($givebackdata);

}

// povraca da je losa/nekompatibilna verzija igre sa serverom bez podatka o verzijama
function BadGameVersion_clean () {
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'bad game version';

  echo json_encode($givebackdata);

}

// povraca da je losa/nekompatibilna verzija igre sa serverom i vraca podatak o obje verzije
function BadGameVersion ($sversion, $gversion) {
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null',
      'server'    => 'null',
      'game'      => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'server and game versions mismatch!';
  $givebackdata ['server']    = $sversion;
  $givebackdata ['game']      = $gversion;

  echo json_encode($givebackdata);

}

// sends back both game and server version .. used for hardcoded checking ( PROBABLY obsolete :D )
function CheckGameVersion ($sversion, $gversion) {
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null',
      'server'    => 'null',
      'game'      => 'null'
  );

  $givebackdata ['operation'] = 'SUCCESS';
  $givebackdata ['reason']    = 'all is well';
  $givebackdata ['server']    = $sversion;
  $givebackdata ['game']      = $gversion;

  echo json_encode($givebackdata);

}


// tell game that we fail to compare hash codes .. means it is broken
function BadHashCode () {
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'wrong hash code bro';

  echo json_encode($givebackdata);

}

// in server check we did send unknown command, and we are not able to do anything useful
function UnknownServerCommand () {
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'unknown server command';

  echo json_encode($givebackdata);

}





// --------------------------------- ACCOUNT MANAGEMENT SPECIFIC messages BEGIN
// used in account_management.php script

function EmailAlreadyInUse () {  // we already have account with that e-mail created
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'There is already account with that mail created';

  echo json_encode($givebackdata);

}

function UsernameAlreadyInUse () {  // we already have account with that e-mail created
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'That profile name is already in use, please change it';

  echo json_encode($givebackdata);

}


function AccountCreated ($uid) {  // success in account creation
  $givebackdata = array (
      'operation' => 'null',
      'description'=> 'null',
      'user_id'   => 'null'
  );

  $givebackdata ['operation'] = 'SUCCESS';
  $givebackdata ['description']= 'Account created';
  $givebackdata ['user_id']   = $uid;

  echo json_encode($givebackdata);

}

function IncorrectLoginDataMail () {  // incorrect e-main in login attempt
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'Login data is wrong, there is no such account with that mail';

  echo json_encode($givebackdata);

}

function IncorrectLoginDataPass () {  // incorect password in login attempt
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'Login data is wrong, password is incorrect';

  echo json_encode($givebackdata);

}

function UserLoginSuccess ($uid, $uda) {  // success in login method
  $givebackdata = array (
      'operation' => 'null',
      'user_id'   => 'null',
      'last_date' => 'null'
  );

  $givebackdata ['operation'] = 'SUCCESS';
  $givebackdata ['user_id']   = $uid;
  $givebackdata ['last_date'] = $uda;

  echo json_encode($givebackdata);

}

function UserIsBanned () {  // this user is banned message
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'This user is banned!';

  echo json_encode($givebackdata);

}

function ProfileDeleted () {  // success in erasing profile
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'SUCCESS';
  $givebackdata ['reason']    = 'User Profile is deleted';

  echo json_encode($givebackdata);

}

function ProfileDeleteFailed () { // profile deletion failed
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'wrong info data for erasing profile! or nothing to delete';

  echo json_encode($givebackdata);

}
// --------------------------------- ACCOUNT MANAGEMENT SPECIFIC messages END





// --------------------------------- GET SCORES messages BEGIN
// USED in scores_get.php
function UnnableToFetchScores () {
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'unnable to fetch scores';

  echo json_encode($givebackdata);
}
// --------------------------------- GET SCORES messages END





// --------------------------------- SET SCORES SPECIFIC MESSAGES BEGIN
// USED in scores_set.php script
function ScoresWritten ($which, $skor) {  // success in writting scores
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'SUCCESS';
  $givebackdata ['reason']    = 'scores ' .$which. ' written for user with score: ' .$skor. ' !';

  echo json_encode($givebackdata);
}


function ScoresUpdated ($which, $skor) {  // success in updating scores
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'SUCCESS';
  $givebackdata ['reason']    = 'new ' .$which. ' score is updated with new score: ' .$skor. ' !';

  echo json_encode($givebackdata);
}

function ScoresObsolete ($which) {  // fail in scores updating (old one is better)
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'no ' .$which. ' score update needed .. new score is lower or same as old one';

  echo json_encode($givebackdata);
}

// --------------------------------- SET SCORES SPECIFIC MESSAGES END

function QualifyFailListing () {  // fail in scores updating (old one is better)
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null',
      'code'      => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'no such user in qualify table at all';
  $givebackdata ['code']      = '0';

  echo json_encode($givebackdata);
}


function QualifyPass ($rank) {  // fail in scores updating (old one is better)
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null',
      'code'      => 'null'
  );

  $givebackdata ['operation'] = 'SUCCESS';
  $givebackdata ['reason']    = 'User passed qualify with rank [' .$rank. ']';
  $givebackdata ['code']      = '1';

  echo json_encode($givebackdata);
}

function QualifyNoPass ($rank) {  // fail in scores updating (old one is better)
  $givebackdata = array (
      'operation' => 'null',
      'reason'    => 'null',
      'code'      => 'null'
  );

  $givebackdata ['operation'] = 'FAIL';
  $givebackdata ['reason']    = 'User NOT passed qualify with rank [' .$rank. ']';
  $givebackdata ['code']      = '2';

  echo json_encode($givebackdata);
}

?>
